﻿using System;
using System.ComponentModel;

namespace TestProject
{
    /// <summary>
    /// 주문
    /// </summary>
    public class Order : INotifyPropertyChanged
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Event
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 속성 변경시 - PropertyChanged

        /// <summary>
        /// 속성 변경시
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 고객 ID
        /// </summary>
        private int customerID;

        /// <summary>
        /// 처리일
        /// </summary>
        private DateTime datefilled;

        /// <summary>
        /// 처리 구분
        /// </summary>
        private string filled;

        /// <summary>
        /// 제품 ID
        /// </summary>
        private int productID;

        /// <summary>
        /// 제품명
        /// </summary>
        private string productName;

        /// <summary>
        /// 주문 ID
        /// </summary>
        private int orderID;

        /// <summary>
        /// 주문일
        /// </summary>
        private DateTime orderdate;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 주문 ID - OrderID

        /// <summary>
        /// 주문 ID
        /// </summary>
        public int OrderID
        {
            get
            {
                return this.orderID;
            }
            set
            {
                this.orderID = value;

                FirePropertyChangedEvent("OrderID");
            }
        }

        #endregion
        #region 고객 ID - CustomerID

        /// <summary>
        /// 고객 ID
        /// </summary>
        public int CustomerID
        {
            get
            {
                return this.customerID;
            }
            set
            {
                this.customerID = value;

                FirePropertyChangedEvent("CustomerID");
            }
        }

        #endregion
        #region 제품명 - ProductName

        /// <summary>
        /// 제품명
        /// </summary>
        public string ProductName
        {
            get
            {
                return this.productName;
            }
            set
            {
                this.productName = value;

                FirePropertyChangedEvent("ProductName");
            }
        }

        #endregion
        #region 제품 ID - ProductID

        /// <summary>
        /// 제품 ID
        /// </summary>
        public int ProductID
        {
            get
            {
                return this.productID;
            }
            set
            {
                this.productID = value;

                FirePropertyChangedEvent("ProductID");
            }
        }

        #endregion
        #region 처리 구분 - Filled

        /// <summary>
        /// 처리 구분
        /// </summary>
        public string Filled
        {
            get
            {
                return this.filled;
            }
            set
            {
                this.filled = value;

                FirePropertyChangedEvent("Filled");
            }
        }

        #endregion
        #region 주문일 - OrderDate

        /// <summary>
        /// 주문일
        /// </summary>
        public DateTime OrderDate
        {
            get
            {
                return this.orderdate;
            }
            set
            {
                this.orderdate = value;

                FirePropertyChangedEvent("OrderDate");
            }
        }

        #endregion
        #region 처리일 - DateFilled

        /// <summary>
        /// 처리일
        /// </summary>
        public DateTime DateFilled
        {
            get
            {
                return this.datefilled;
            }
            set
            {
                this.datefilled = value;

                FirePropertyChangedEvent("DateFilled");
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - Order(orderID, customerID, productName, productID, filled, orderDate)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="orderID">주문 ID</param>
        /// <param name="customerID">고객 ID</param>
        /// <param name="productName">제품명</param>
        /// <param name="productID">제품 ID</param>
        /// <param name="filled">처리 구분</param>
        /// <param name="orderDate">주문일</param>
        public Order(int orderID, int customerID, string productName, int productID, string filled, DateTime orderDate)
        {
            OrderID     = orderID;
            CustomerID  = customerID;
            ProductName = productName;
            ProductID   = productID;
            Filled      = filled;
            OrderDate   = orderDate;
        }

        #endregion
        #region 생성자 - Order(orderID, customerID, productName, productID, filled, orderDate, dateFilled)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="orderID">주문 ID</param>
        /// <param name="customerID">고객 ID</param>
        /// <param name="productName">제품명</param>
        /// <param name="productID">제품 ID</param>
        /// <param name="filled">처리 구분</param>
        /// <param name="orderDate">주문일</param>
        /// <param name="dateFilled">처리일</param>
        public Order(int orderID, int customerID, string productName, int productID, string filled, DateTime orderDate, DateTime dateFilled)
        {
            OrderID     = orderID;
            CustomerID  = customerID;
            ProductName = productName;
            ProductID   = productID;
            Filled      = filled;
            OrderDate   = orderDate;
            DateFilled  = dateFilled;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 속성 변경시 이벤트 발생시키기 - FirePropertyChangedEvent(propertyName)

        /// <summary>
        /// 속성 변경시 이벤트 발생시키기
        /// </summary>
        /// <param name="propertyName">속성명</param>
        private void FirePropertyChangedEvent(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}